using System.Diagnostics;

using HttpClientStudy.Core.Utils;

var builder = WebApplication.CreateBuilder(args);

// Add services to the container.

builder.Services.AddControllers();
// Learn more about configuring Swagger/OpenAPI at https://aka.ms/aspnetcore/swashbuckle
builder.Services.AddEndpointsApiExplorer();
builder.Services.AddSwaggerGen();

var app = builder.Build();

// Configure the HTTP request pipeline.
if (app.Environment.IsDevelopment())
{
    app.UseSwagger();
    app.UseSwaggerUI();
}

app.UseAuthorization();

app.MapControllers();

Process currentProcess = Process.GetCurrentProcess();
currentProcess.EnableRaisingEvents = true;
currentProcess.Exited += (s, r) => 
{
    Console.WriteLine("000000000000000000000000000000000000");
};


// ȡ IHostApplicationLifetime ʵ
var applicationLifetime = app.Services.GetRequiredService<IHostApplicationLifetime>();

// עӦóر¼
applicationLifetime.ApplicationStopping.Register(() => 
{
    //رWebApi
    StartupUtility.ExitWebApiProject();
});

applicationLifetime.ApplicationStopped.Register(() => {
    Console.WriteLine("xxxxxxxxxxxxxxxxxxxx");
});

// ע AppDomain δ쳣¼
AppDomain.CurrentDomain.UnhandledException += (s,e)=> 
{
    Console.WriteLine("˳");
};


//ȷWebApi
StartupUtility.StartWebApiProject();

app.Run();
